deff('[mat] = hilb(dim)','for i = 1:dim;for j=1:dim;mat(i,j)=1/(i+j+1);end;end'); // matrice de Hilbert
//
for dim=4:4:20
      mat=hilb(dim);
	printf('Ordre=%d  Rang=%d\n',dim,rank(mat));
	printf('Norme (1) =%g\n',norm(mat,1));
	printf('Norme (2) =%g\n',norm(mat,2));
	printf('Conditionnement =%g\n',cond(mat));
	printf('Estimation du conditionnement =%g\n',1./rcond(mat));
	printf('Erreur sur inv(mat)*mat: %g\n',norm(inv(mat)*mat - eye(mat)));
	xorig = ones(dim,1);
	b=mat * xorig;
//
	x=mat\b;
	printf('Erreur relative sur resolution Ax=b par Gauss: %g\n',norm(x-xorig)./norm(xorig));
	y=linsolve(mat,-b);
	printf('Erreur relative sur resolution Ax=b par linsolve: %g\n',norm(y-xorig)./norm(xorig));
end

