long=%pi;c=1;
xbasc()
deff('y=u0(x)','y=sin(x)');
N=evstr(x_dialog('nombre de points interieurs','100'));
h=long/(N+1);X=(h*(1:N))';
T=evstr(x_dialog('temps a calculer','10'));
m=evstr(x_dialog('nombre de pas de temps','200'));dt=T/m;
disp('dx=');disp(h);disp('dt=');disp(dt);
//
A=1/h^2*toeplitz([2,-1,zeros(1,N-2)]);
u1=u0(X);u2=u1;v1=u1;v2=u2;
//
// methode explicite
//
timer();
for i=1:(m-1)
  u1b=u2;u2=-dt^2*A*u2+2*u2-u1;u1=u1b;
end
disp('temps de calcul methode explicite');disp(timer());
//
// methode implicite
//
timer();
[L,U]=lu(eye(N,N)+dt^2/4*A);
for i=1:(m-1)
  v1b=v2;
//v2=inv(eye(N,N)+dt^2/4*A)*(2*v2-1/2*dt^2*A*v2-1/4*dt^2*A*v1-v1);
v3=linsolve(L,-2*v2+1/2*dt^2*A*v2+1/4*dt^2*A*v1+v1);v2=linsolve(U,-v3);
v1=v1b;
end
disp('temps de calcul methode implicite');disp(timer());
//
X=[0;X;long];u2=[0;u2;0];v2=[0;v2;0];uex=cos(T)*u0(X);
xsetech([0,0,0.5,1])
plot2d([X,X,X],[u2,v2,uex],leg='explicite@implicite@exact');
xsetech([0.5,0,0.5,1])
plot2d([X,X],[v2,uex],[2,3],leg='implicite@exact');