function u=fct_gauss(a2,b)
//
// resolution de a2.u=b par la methode de Gauss 
//
[imax,jmax]=size(a2);
for j=2:imax
    for i=j:imax
      pivot=a2(j-1,j-1);
      kp=j-1;
      for k=j-1:imax
        if abs(a2(k,j-1))>abs(pivot) then
          pivot=a2(k,j-1);
          kp=k;
        end
      end
      a3=a2(j-1,j-1:imax);
      a2(j-1,j-1:imax)=a2(kp,j-1:imax);
      a2(kp,j-1:imax)=a3;
      b3=b(j-1);
      b(j-1)=b(kp);
      b(kp)=b3;
	m=a2(i,j-1)/a2(j-1,j-1);
      a2(i,:)=a2(i,:)-a2(j-1,:)*m;
      b(i)=b(i)-m*b(j-1);
    end
end
u=zeros(imax,1);
u(imax)=b(imax)/a2(imax,imax);
for j=imax-1:-1:1,
  u(j)=(b(j)-a2(j,j+1:imax)*u(j+1:imax))/a2(j,j);
end
//

